import utils

class Reader:
    def __init__(self,stats):
        self.stats = stats
        # -------------------------------        
        # flags
        # -------------------------------
        self._string            = False
        self._depth             = 0
        self._open_parens       = 0

    def process(self,code):
        """
        beginning of docstring :
        '''      -> line.startswith(''')
        ''' blah -> line.startswith(''')
        end of docstring
        '''      -> line.endswith(''')
        blah ''' -> line.endswith(''')
        
        """
        docstring = False
        nquotes   = 0
        for line in code :
            _line = line.strip()
            utils.debug("[DEBUG Reader.process]",_line,len(_line))
            if (_line.startswith('#')):
                utils.debug("[DEBUG Reader.process] COMMENT")
                continue
            elif (not _line):
                utils.debug("[DEBUG Reader.process] BLANK LINE")
                continue
            nquotes = _line.count('"""')
            if nquotes :
                utils.debug("[DEBUG Reader.process] Begining or end of ML docstring")
                docstring = (not docstring, docstring)[nquotes == 2]
                continue
            if not docstring:
                self._parse(line)
                
    def _parse(self,line):
        _line = line.lstrip()
        missing = _line.count("(") + _line.count("[") - _line.count(")") - _line.count("]")
        # make sure that there's really something missing
        if missing :
            utils.debug("[DEBUG Reader._parse] paren mismatch", missing)
            try:
                compile(_line,"/tmp/tmpcode","single")
                utils.debug("[DEBUG Reader._parse] line compiles.")
            except SyntaxError,e:
                utils.debug("[DEBUG Reader._parse] line doesn't compile")
                self._open_parens += missing
        self._process_indents(line)
        definition = self._visit_defs_classes(_line)
        utils.debug("[DEBUG Reader._parse] is this a definition", definition)
        utils.debug("[DEBUG Reader._parse] is there a missing paren", self._open_parens)
        self.stats.register_loc(line,not(self._open_parens or definition))
        
    def _process_indents(self,line):
        _line   = line
        indents = 0
        token   = None
        if line.startswith("    "):
            token = "    "
        elif line.startswith("\t"):
            token = "\t"
        if token :
            while _line.startswith(token) :
                _line = _line[4:]
                indents += 1
        if not indents and not self._depth:
            return 
        if indents > self._depth:
            self._depth += 1
        elif indents < self._depth:
            self._depth = indents
            self.stats.change_depth(self._depth)
             
    def _visit_defs_classes(self,_line):
        visitor = {
                    "class ": self.stats.register_class,
                    "def "  : self.stats.register_def,
                   }
        for key in visitor : 
            if _line.startswith(key):
                token = (':','(')['(' in _line]
                name  = "".join(_line.split(key)[1:]).split(token)[0]
                visitor[key](name,self._depth)
                return True
            
